<template>
  <v-layout>
    <v-flex xs6 sm5 md4 :style="{
      'height': 'calc(100vh - 64px - 36px)',
      'max-height': 'calc(100vh - 64px - 36px)',
      'overflow': 'auto'
    }">
      <Address
        name="From"
        :address="from"
        @edit="selectedAddress = from"
        @search="searchAddress(from)"
      />
      <Address
        name="To"
        :address="to"
        @edit="selectedAddress = to"
        @search="searchAddress(to)"
      />

      <NominatimResult
        v-if="nominatimResult"
        :results="nominatimResult"
        :loading="nominatimLoading"
        @select="selectMarker"
        @over="displayMarker"
        @out="hideMarker"
      />

      <AddressForm
        v-if="selectedAddress"
        :address="selectedAddress"
      />
    </v-flex>
    <v-flex xs6 sm7 md8>
      <Map
        :nominatim-result='nominatimResult'
        :overpass-result='overpassResult'
        :center='center'
        :current-marker='currentNominatimResult'
        @bbox='searchOverpass'
      >
        <template slot="popup">
          <div v-if="currentNominatimResult !== ''">
            {{ currentNominatimResult.display_name }}
          </div>
          <div v-else>
            Aucune adresse sélectionnée.
          </div>
        </template>
      </Map>
    </v-flex>
  </v-layout>
</template>

<script>
import Address from '@/components/Address'
import AddressForm from '@/components/AddressForm'
import NominatimResult from '@/components/NominatimResult'
import Map from '@/components/Map'

import { getOverpassData } from '@/services/overpass'

const NOMINATIM_URL = 'http://nominatim.openstreetmap.org/search/'
const DEFAULT_FORMAT = '?format=json'

export default {
  components: {
    Address,
    AddressForm,
    NominatimResult,
    Map
  },
  data () {
    return {
      selectedAddress: null,
      nominatimResult: null,
      overpassResult: null,
      center: {},
      currentNominatimResult: '',
      nominatimLoading: false,
      from: {
        road: '1 Place Wilson',
        zipCode: '31000',
        city: 'Toulouse',
        complement: 'Bloom Multimédia',
        country: 'Occitanie',
        state: null
      },
      to: {
        road: 'place du Capitole',
        zipCode: 31000,
        complement: 'pouet',
        city: 'Toulouse',
        state: 'France'
      }
    }
  },
  methods: {
    logMouseOver: console.log,
    async searchAddress (addressToSearch) {
      const nominatimUrl = `${NOMINATIM_URL}${addressToSearch.road} ${addressToSearch.zipCode} ${addressToSearch.city}${DEFAULT_FORMAT}`
      this.nominatimLoading = true
      const response = await fetch(nominatimUrl)
      this.nominatimResult = await response.json()
      this.nominatimLoading = false
    },
    selectMarker (item) {
      this.center = item
    },
    displayMarker (item) {
      this.currentNominatimResult = item
    },
    hideMarker () {
      this.currentNominatimResult = ''
    },
    async searchOverpass (bbox) {
      this.loadingOverpass = true
      const response = await getOverpassData(bbox)
      this.loadingOverpass = false
      this.overpassResult = response
    }
  },
  created () {
    if (this.$route.params.address) {
      this.from = JSON.parse(this.$route.params.address)
    }
    if (this.from) {
      this.searchAddress(this.from)
    }
  }
}

</script>
